/***************************************************************************
 *
 *     File: helpers.h
 *
 *     Description: Common helper functions used throughout captureOEM
 *
 */

#ifndef PIXELINK_HELPERS_H_
#define PIXELINK_HELPERS_H_

#include <gtk/gtk.h>
#include "pxlport.h"
#include "LinuxTypes.h"


void IncrementFileName(GtkEntry *entry, const char* format);
void ReplaceFileExtension(GtkEntry *entry, const char* newExtension);

// scope guard for critical sections
class AutoCS
{
public:
    explicit AutoCS(pxlmutex_t& cs, BOOL bLock=TRUE)
        :m_cs(cs)
        ,m_bLocked(bLock)
    {
       if(m_bLocked) PxLMutexLock(m_cs);
    }
    ~AutoCS()
    {
        if(m_bLocked) PxLMutexUnlock(m_cs);
    }
private:
    pxlmutex_t& m_cs;
    BOOL m_bLocked;
};



#endif /* PIXELINK_HELPERS_H_ */
